﻿using SushiBarContracts.BindingModels;
using SushiBarContracts.SearchModels;
using SushiBarContracts.ViewModels;
using SushiBarDataModels.Models;

namespace SushiBarContracts.BusinessLogicsContracts
{
    public interface IStoreLogic
    {
        List<StoreViewModel>? ReadList(StoreSearchModel? model);
        StoreViewModel? ReadElement(StoreSearchModel model);
        bool Create(StoreBindingModel model);
        bool Update(StoreBindingModel model);
        bool Delete(StoreBindingModel model);
        bool SupplySushi(StoreSearchModel model, ISushiModel sushi, int quantity);
        bool CheckToSupply(ISushiModel sushi, int quantity);
        bool SellSushi(ISushiModel model, int quantity);
    }
}
