﻿using SushiBarContracts.BindingModels;
using SushiBarContracts.ViewModels;
using SushiBarDataModels.Models;

namespace SushibarListImplement.Models
{
    public class Store : IStoreModel
    {
        public string StoreName { get; private set; } = string.Empty;
        public string StoreAddress { get; private set; } = string.Empty;
        public DateTime OpeningDate { get; private set; }
        public Dictionary<int, (ISushiModel, int)> Sushis { get; private set; } = new();
        public int maxSushi { get; }
        public int Id { get; private set; }

        public static Store? Create(StoreBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Store()
            {
                Id = model.Id,
                StoreName = model.StoreName,
                StoreAddress = model.StoreAddress,
                OpeningDate = model.OpeningDate,
                Sushis = new Dictionary<int, (ISushiModel, int)>()
            };
        }

        public void Update(StoreBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            StoreName = model.StoreName;
            StoreAddress = model.StoreAddress;
            OpeningDate = model.OpeningDate;
            Sushis = model.Sushis;
        }

        public StoreViewModel GetViewModel => new()
        {
            Id = Id,
            StoreName = StoreName,
            StoreAddress = StoreAddress,
            OpeningDate = OpeningDate,
            Sushis = Sushis
        };
    }
}
